#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <libporty/net/network.h>
#include <libporty/net/local.h>

int test(void)
{
	P_net_socket s1, s2;
	char line[64];
	int len;

	if (P_net_local_socket(&s1, &s2, 0) !=0) {
		printf("ERROR: Can't make local socket pair\n");
		return 1;
	}

	P_net_write(s1, "test\n", 5);
	len = P_net_read(s2, line, sizeof(line));
	if (len > 0) {
		line[len] = '\0';
		if (strcmp(line, "test\n") != 0) {
			printf("ERROR: couldn't read 'test' in s1->s2: '%s'\n", line);
			return 2;
		}
	}
	else {
		printf("ERROR: couldn't read anything in s1->s2 direction: %d\n", len);
		perror("read:");
		return 3;
	}

	P_net_write(s2, "test\n", 5);
	len = P_net_read(s1, line, sizeof(line));
	if (len > 0) {
		line[len] = '\0';
		if (strcmp(line, "test\n") != 0) {
			printf("ERROR: couldn't read 'test' in s2->s1: '%s'\n", line);
			return 4;
		}
	}
	else {
		printf("ERROR: couldn't read anything in s1->s2 direction: %d\n", len);
		return 5;
	}

	P_net_printf_minbuff = 4;
	P_net_printf_maxbuff = 32;
	P_net_printf(s1, "This is a %s text\n", "long");
	len = P_net_read(s2, line, sizeof(line));
	if (len > 0) {
		line[len] = '\0';
		if (strcmp(line, "This is a long text\n") != 0) {
			printf("ERROR: couldn't read 'This is a long text' after P_net_printf: '%s'\n", line);
			return 6;
		}
	}
	else {
		printf("ERROR: couldn't read anything after P_net_printf: %d\n", len);
		return 7;
	}

	printf("OK.\n");
	return 0;
}

int main()
{
	int ret;
	P_net_init();
	srand(time(NULL));
	ret = test();
	P_net_uninit();
	return ret;
}
